function [motif_model] = build_motif_model(seq, pseudocount)

len = size(seq, 2);
letters = 4;

seq_int = nt2int(seq);
base = zeros(letters, len) + pseudocount;
for i = 1:len
	if seq_int(i) >= 1 && seq_int(i) <= size(base, 1)
		base(seq_int(i), i) = base(seq_int(i), i) + 1.0;
	else
		base(:, i) = base(:, i) + (ones(size(base(:, i))) * (1.0 / letters));
	end
end

motif_model = normalize_matrix(base);

