function [log_likelihood, expect_array] = expectation(seq_idx, seqs, log_prior, log_mask, log_motif_model, log_bg_model)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This function walks down a sequence (seqs(seq_idx, :)), and
%% calculates the expectation at each point (which includes
%% the motif's contribution, the background's contribution,
%% the array of prior probabilities, and the "masking array"
%% for multiple motif discovery.
%% 'log_likelihood' is the sum of the unnormalized probabilities.
%% 'expect_array' is the (non-log) array of (normalized) expecations.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

window = size(log_motif_model, 2);
total = -1.0e99;
log_likelihood = -1.0e99;

inds = [1:size(seqs(seq_idx, :),2) - window];
log_expect_array = zeros(1, size(seqs(seq_idx, :),2)-window);

for i = 1:size(seqs(seq_idx, :), 2) - window

	%% ** MISSING **	
	%% Write the code that is missing from this point.  The value of 
	%% log_expect_array(i) needs to be assigned, and the value of log_likelihood
	%% needs to be properly updated.
	%% The first value should be calculated with (at least) a call to log_point_expectation().
	%% ** MISSING **	

	total = log_add(total, log_expect_array(i));
end

log_expect_array = log_expect_array - total;  % normalization step.
expect_array = exp(log_expect_array);  %% we need to return a non-log array.

