function [updated_counts, updated_bg_counts] = expected_counts(seq, expectation, counts, bg_counts, window)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Updates both background and motif models from a single sequence.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

L = size(seq, 2);
weight = 1.0;

for i = 1:L
	%% Update the Motif %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%% 
	%% ** MISSING **
	%% Fill in the code missing from here, which updates the current 'counts'
	%% variable for the motif with the weighted sequence counts (weighted with
	%% the expectations in 'expectation').
	%% ** MISSING **

	%% Update the Background %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%% The background is a little tricky, because the weight of 
	%% a single position *is not* 1-expectation(i) at that position.
	%% Rather, the weight of a position for counting into the 
	%% background should be the probability that it's not in *any*
	%% of the overlapping windows, which is a product.
	%% We update this product-weight dynamically as we walk down the 
	%% sequence, so we don't have to recalculate a K-length product
	%% at *each* position.
	if i <= L-window
		expect = expectation(i);
	else
		expect = 0.0
	end

	if expect < 1.0
		weight = weight * (1.0-expect);
	end

	if i - window > 0 && expectation(i-window) < 1.0
		weight = weight / (1.0-expectation(i-window));
	end
	%bg_counts(seq(i)) = bg_counts(seq(i)) + (1.0 - weight);
	bg_counts(seq(i)) = bg_counts(seq(i)) + weight;
end

updated_counts = counts;
updated_bg_counts = bg_counts;

