function[maximum_offsets, log_mask_array] = mask_log_priors(log_mask_array, log_expectations, w)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% There are a variety of different ways of "masking" out previously-
%% discovered motifs during multiple-motif-discovery.  We choose here
%% to effectively zero-out the surrounding area around the maximum 
%% point (in terms of expectation) on each sequence.  But one could 
%% imagine other, softer schema for masking out previously-discovered
%% sites.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hw = floor(w/2);
[maxima, maximum_offsets] = max(log_expectations');

for i =1:size(log_mask_array, 1)
	offset = maximum_offsets(i);

	%weight = log(1.0 - exp(log_expectations(i, offset)));
	%weight = -1.0e99;
	%weight = log(0.001);
	weight = log(1.0e-99);

	start = max(1, offset-hw);
	stop = min(size(log_mask_array, 2), offset+hw);
	for j = start:stop
		log_mask_array(i, j) = log_mask_array(i, j) + weight;
	end
end

