function[hits, misses, hit_records] = scan_fasta_file(fasta_filename, log_motif_model, log_threshold)

window = size(log_motif_model, 2);

hits = 0;
misses = 0;

seq_records = fastaread(fasta_filename);
fprintf(1, 'Loaded Records (%d / %f)...\n', size(seq_records, 2), log_threshold);

for i =1:size(seq_records, 2)
	seq_ints = nt2int(seq_records(i).Sequence);

	satisfied = 0; 
	j = 1;

	while j <= size(seq_ints, 2) - window && satisfied == 0
		sub_seq = seq_ints(j:j+window-1);
		log_p = motif_log_prob(log_motif_model, sub_seq);
		if log_p >= log_threshold
			satisfied = 1;
		end
		j = j + 1;
	end

	if satisfied == 1	
		hits = hits + 1;	
		fprintf(1, '*');
		hit_records(hits) = seq_records(i);
	else
		misses = misses + 1;
		fprintf(1, '-');
	end
	
	if rem(i, 100) == 0
		fprintf(1, '[%d]', i);
	end
end
fprintf(1, '\n');

